% QUANTIZAO: FIG 25 (pag.72)
% Script para a imagem do efeito da quantificao na resposta de um sitema de controlo
%
% Coelho, J.P. (2005/2006). "CONTROLO DIGITAL - Material de Apoio s Aulas". Instituto Politcnico de Bragana, 
% Escola Superior de Tecnologia e Gesto.(2005/2006)
%
% WEB: www.ipb.pt/~jpcoelho
% E-mail: jpcoelho@ipb.pt
%
% Copyright 2006
%
% Este "script" pode ser usado livremente desde que devidamente referenciado.
% Este cdigo apenas pode ser usado para fins educacionais. 
% Qualquer utilizao pblica desta rotina requer a autorizao expressa do autor 


s=tf('s');
% Sinal (rampa)
nsamp=500;
T=0.01;
t=0:T:5;
r=2*t;
% Sinal quantificado
rq=quant(r,5,0,10);
plot(t,r,t,rq)
% Considerar um sistema de 1 ordem
G_s=0.1/(s+0.1);
%resposta impulsional
h_t=0.1*exp(-0.1*t);

[y1,t1]=lsim(G_s,r,t);
[y2,t2]=lsim(G_s,rq,t);
figure
plot(t,y1,t,y2)
figure
plot(t,y1-y2)
disp('erro');
e=y1-y2;
e=sqrt((e'*e)/length(e))
figure
y=T*conv(h_t,r);
k=0:length(y)-1;
plot(t,y1,t,y2,t,y(1:length(y1)));