% RELAO ENTRE LARGURA DE BANDA, IMUNIDADE AO RUDO E POSIO DO PLO DE UM SISTEMA DE PRIMEIRA ORDEM
%
% Coelho, J.P. (2005/2006). "CONTROLO DIGITAL - Material de Apoio s Aulas". Instituto Politcnico de Bragana, 
% Escola Superior de Tecnologia e Gesto.(2005/2006)
%
% WEB: www.ipb.pt/~jpcoelho
% E-mail: jpcoelho@ipb.pt
%
% Copyright 2006
%
% Este "script" pode ser usado livremente desde que devidamente referenciado.
% Este cdigo apenas pode ser usado para fins educacionais. 
% Qualquer utilizao pblica desta rotina requer a autorizao expressa do autor 

polos=[0.1 0.5 1];
t=0:0.01:60;
y=zeros(length(t),3);

for k=1:3
   num=polos(k);
   den=[1 polos(k)];
   sys=tf(num,den);
   [y(:,k),x]=step(sys,t);
end

plot(t,y)
xlabel('Tempo/s');
ylabel('Amplitude');
legend('0.1/(s+0.1)','0.5/(s+0.5)','1/(s+1)');
axis([0 60 0 1.1]);
grid on

polos=[0.1 1];
t=0:0.01:60;
u=ones(size(t))+0.3*randn(size(t));
y=zeros(length(t),3);

for k=1:2
   num=polos(k);
   den=[1 polos(k)];
   sys=tf(num,den);
   [y(:,k),x]=lsim(sys,u,t);
end

plot(t,y)
xlabel('Tempo/s');
ylabel('Amplitude');
legend('0.1/(s+0.1)','1/(s+1)');
axis([0 60 0 1.1]);
grid on


