% EFEITO DE UM FILTRO NO CANCELAMENTO DE ZEROS DE MALHA FECHADA
%
% Coelho, J.P. (2005/2006). "CONTROLO DIGITAL - Material de Apoio s Aulas". Instituto Politcnico de Bragana, 
% Escola Superior de Tecnologia e Gesto.(2005/2006)
%
% WEB: www.ipb.pt/~jpcoelho
% E-mail: jpcoelho@ipb.pt
%
% Copyright 2006
%
% Este "script" pode ser usado livremente desde que devidamente referenciado.
% Este cdigo apenas pode ser usado para fins educacionais. 
% Qualquer utilizao pblica desta rotina requer a autorizao expressa do autor 
%

% Cdigo para acetatos de controlo digital
s=tf('s');
%sistema a controlar:
G_s=1/(s*(0.67*s+1));
%1 controlador estimado
K_s=452*(s+9.54)/(s+50);
%pr-filtro
F_s=9.54/(s+9.54);
%funo de transferncia de malha fechada...
Gcl_s=feedback(K_s*G_s,1);
figure;subplot(2,1,1);[y1,t1]=step(Gcl_s);[y2,t2]=step(F_s*Gcl_s,t1);
plot(t1,y1,t2,y2);legend('Sem Pr-Filtro','Com Pr-Filtro');grid on
% repare na diminuio da sobre-elongao mantendo, no entanto, o tempo de estabelecimento.
subplot(2,1,2);[y1,t1]=step(Gcl_s/s);[y2,t2]=step(F_s*Gcl_s/s,t1);
plot(t1,t2,t1,y1,t2,y2);legend('Entrada','Sem Pr-Filtro','Com Pr-Filtro');grid on




