% MOSTRA O EFEITO DO ALIASING E A FORMA COMO  CONTORNADO A PARTIR DE UM FILTRO ANALGICO
%
% Coelho, J.P. (2005/2006). "CONTROLO DIGITAL - Material de Apoio s Aulas". Instituto Politcnico de Bragana, 
% Escola Superior de Tecnologia e Gesto.(2005/2006)
%
% WEB: www.ipb.pt/~jpcoelho
% E-mail: jpcoelho@ipb.pt
%
% Copyright 2006
%
% Este "script" pode ser usado livremente desde que devidamente referenciado.
% Este cdigo apenas pode ser usado para fins educacionais. 
% Qualquer utilizao pblica desta rotina requer a autorizao expressa do autor 


clear all
Famo=46;                       % Frequncia de amostragem (Hz)
Fsim=100*Famo;                 % Frequncia para a simulao
t=0:1/Fsim:2;                  % Vector de tempo
sinal=sin(2*pi*1*t);           % Sinal sinusoidal a girar  frequncia de 2pi rad/s i.e. 1 Hz
ruido=0.2*sin(2*pi*50*t+pi/4); % Ruido de alta frequncia 50 Hz (p. ex. f.e.m. induzida pela rede de distribuio electrica)
scontaminado=sinal+ruido;      % Sinal contaminado
k=1:100:length(t);
subplot(2,2,1);plot(t,scontaminado);axis([0 2 -1.5 1.5]);
subplot(2,2,2);plot(t(k),scontaminado(k));axis([0 2 -1.5 1.5]);
% Filtro anti-aliasing de primeira ordem com frequncia de corte igual  frequencia de Nyquist
Fc=Famo/2; %Hz % Frequencia de corte /cut-off frequency
% ANALGICO       
numfs=pi*Fc;denfs=[1 pi*Fc];Gf_s=tf(numfs,denfs);sfilt2=lsim(Gf_s,scontaminado,t);          
% DIGITAL
numfz=(1/Fsim)*[pi*Fc];denfz=[1 -exp(-pi*Fc/Fsim)];sfilt=filter(numfz,denfz,scontaminado);
% Nota: COMPARE AS DUAS VERSES E CONCLUA ....   ;)
% Mostra os resultados da simulao com e sem filtro anti-aliasing
subplot(2,2,3);plot(t,sfilt,t,sfilt2,'r');axis([0 2 -1.5 1.5]);
subplot(2,2,4);plot(t(k),sfilt(k),'r');axis([0 2 -1.5 1.5]);
