% EFEITO DO PR-FILTRO NA RESPOSTA DE UM SISTEMA DISCRETO: MARGEM DE FASE 
%
% Coelho, J.P. (2005/2006). "CONTROLO DIGITAL - Material de Apoio s Aulas". Instituto Politcnico de Bragana, 
% Escola Superior de Tecnologia e Gesto.(2005/2006)
%
% WEB: www.ipb.pt/~jpcoelho
% E-mail: jpcoelho@ipb.pt
%
% Copyright 2006
%
% Este "script" pode ser usado livremente desde que devidamente referenciado.
% Este cdigo apenas pode ser usado para fins educacionais. 
% Qualquer utilizao pblica desta rotina requer a autorizao expressa do autor 

%
clear all;close all;
s=tf('s');

% Sistema Analgico
%            76
% G(s)=--------------
%       (s+1)(s+3)^2
%
% Restries:
% 	- ess <10%
%	- Pm ~ 45
%	- BW<2 rad/s

G_s=76/((s+1)*(s+3)^2);            % Funo de Transferencia
K_s=1.851*(0.494*s+1)/(14.49*s+1); % Controlador Analgico
Gcl_s=feedback(G_s*K_s,1);			  % Funo de Transferncia de Malha Fechada
BW=1.4;  								  % Largura de Banda em Malha Fechada
wgc=0.83;								  % Frequencia de Cruzamento de Ganho
wo=30*BW;   							  % Frequncia e Perodo de Amostragem
T=2*pi/wo;
Gf_s=(wo/2)/(s+(wo/2));				  % Filtro anti-aliasing
GGzoh_z=c2d(G_s,T,'zoh');          % Discretizao do sistema + zoh
GGfGzoh_z=c2d(G_s*Gf_s,T,'zoh');   % Discretizao do sistema + zoh + filtro anti-aliasing
K_z=c2d(K_s,T,'tustin')				  % Discretizao do controlador: transf. Bilinear

% Relao entre resposta em frequncia da estratgia de controlo Analogica Vs Digital
[M2,F2,W1]=bode(K_z*GGzoh_z);
M2=M2(:);F2=F2(:);
[M1,F1]=bode(K_s*G_s,W1);
M1=M1(:);F1=F1(:);
[M3,F3]=bode(K_z*GGfGzoh_z,W1);
M3=M3(:);F3=F3(:);
figure;subplot(2,1,1);
semilogx(W1,20*log10(M1),W1,20*log10(M2),W1,20*log10(M3))
grid on
legend('Analgico','Digital sem Pr-Filtro','Digital com Pr-Filtro');
ylabel('Magnitude/dB');
xlabel('Frequncia/rad.s^-1');
subplot(2,1,2);
semilogx(W1,F1,W1,F2,W1,F3);
grid on
legend('Analgico','Digital sem Pr-Filtro','Digital com Pr-Filtro');
ylabel('Fase/');
xlabel('Frequncia/rad.s^-1');

% Funo de Transferncia MF sem pr-filtro
Gcl_z=feedback(K_z*GGzoh_z,1)
% Funo de Transferncia MF com pr-filtro
Gcl_f_z=K_z*GGzoh_z/(1+K_z*GGfGzoh_z)
figure; step(Gcl_z,Gcl_f_z,0:T:100*T)