% PROJECTO DE UM CONTROLADOR DIGITAL POR EMULAO (pag. 143 a 149)
%
% Coelho, J.P. (2005/2006). "CONTROLO DIGITAL - Material de Apoio s Aulas". Instituto Politcnico de Bragana, 
% Escola Superior de Tecnologia e Gesto.(2005/2006)
%
% WEB: www.ipb.pt/~jpcoelho
% E-mail: jpcoelho@ipb.pt
%
% Copyright 2006
%
% Este "script" pode ser usado livremente desde que devidamente referenciado.
% Este cdigo apenas pode ser usado para fins educacionais. 
% Qualquer utilizao pblica desta rotina requer a autorizao expressa do autor 


s=tf('s');
G_s=76/((s+1)*(s+3)^2); % O sistema...
BW=1.5;						% Largura de banda desejada
wgc=BW/2;					% Frequencia de cruzamento de ganho
Pm=45;						% Margem de fase desejada	
K=2;							% Ganho inicial
[m,f]=bode(K*G_s,wgc);  % Clculo do ganho@w=wgc
wp=wgc/sqrt(m^2-1);     % Frequencia do plo
[m,f]=bode(K*G_s/((s/wp)+1),wgc); % Clculo da fase @w=wgc
PHI=(Pm+5)-(180+f);					 % Avano de fase desejado (inclui efeito do zoh+filtro)
wz=wgc/(tan(PHI*pi/180));  		 % Frequencia do zero
delta=sqrt((wgc/wz)^2+1);         % Atenuao do ganho...
K=K/delta;
K_s=K*((s/wz)+1)/((s/wp)+1)       % Funo de transferencia do controlador
margin(K_s*G_s);                  % Margem de ganho e fase
Gcl_s=feedback(K_s*G_s,1);        % Largura de banda de malha fechada
figure;step(Gcl_s);               % Resposta ao degrau
wo=30*BW;                         % Frequencia de amostragem
T=2*pi/wo;                        % Perodo de Amostragem
K_z=c2d(K_s,T,'tustin');			 % Discretizao do controlador (bilinear)
GGzoh_z=c2d(G_s,T,'zoh');         % Sistema + ZOH
Gf_s=(wo/2)/(s+(wo/2));           % Filtro anti-aliasing
GGfGzoh_z=c2d(G_s*Gf_s,T,'zoh')   % Sistema+ZOH+filtro
Gcl_z=(K_z*GGzoh_z)/(1+K_z*GGfGzoh_z); % F.T de malha fechada 
figure;step(Gcl_z,0:T:20)              % Resposta ao degrau
figure;margin(K_z*GGfGzoh_z)				% Margem de ganho e fase: observe a F.T usada ;)
figure;bode(Gcl_z)							% Largura de banda
