function S=sylvester(N,D)

% CONSTROI A MATRIZ DE SYLVESTER
% (para ser usada no contexto do controlo UFC)
%
% Coelho, J.P. (2005/2006). "CONTROLO DIGITAL - Material de Apoio s Aulas". Instituto Politcnico de Bragana, 
% Escola Superior de Tecnologia e Gesto.(2005/2006)
%
% WEB: www.ipb.pt/~jpcoelho
% E-mail: jpcoelho@ipb.pt
%
% Copyright 2006
%
% Este "script" pode ser usado livremente desde que devidamente referenciado.
% Este cdigo apenas pode ser usado para fins educacionais. 
% Qualquer utilizao pblica desta rotina requer a autorizao expressa do autor 


s1=[fliplr(D)' fliplr(N)'];
n=length(roots(D));
i=ones(2*n,1)*(1:n+1);
i=i';i=i(:);
ii=ones(2*(n+1),1)*(0:n-1);
ii=ii(:);i=i+ii;
j=ones(n+1,1)*(1:2*n);j=j(:);
S=full(sparse(i,j,kron(ones(n,1),s1(:))));


% outra forma...
% (computacionalmente menos eficiente ;) ) 
%
% Ref: [Shahian e Hassul. "Control System Design Using Matlab", Prentice Hall]

%s1=[fliplr(D)' fliplr(N)'];
%nn=length(D);
%n=nn-1;
%sylv=zeros(2*n);
%for i=1:2:2*n-1
%   bgnrow=(i+1)/2;
%   sylv(bgnrow:bgnrow+n,i:i+1)=s1;
%end
